
% weighted distribution sampler
% p is a row vector of parameters, p=[p_1,p_2,...,p_n] with \sum(p_i)=1;
% k is the sample size

function r = multirnd1(p,n,k)

m = length(p)/n;

for i=1:n
    r(i,:)=randsample([1:m],k,true,p((i-1)*m+1:(i-1)*m+m));
end

r=r';